-- ******************************************************************
-- ******************************************************************
-- **                         MorgBid                              			   **
-- ******************************************************************
-- ******************************************************************
--
--  Most of this code is Fryguy's:) Thanks for your hard work:)
--

MorgBid = {}

MorgBid.Locals = { }
MorgBidDB = { }

local L = MorgBid.Locals

L.passhint = "Pass.\nUse this option if you do not need this item"
L.takehint = "Take.\nUse this option if you are able to take this\nitem, but do not necessarily want it or\nwould prefer someone else take it first.\nAlternatively use this button if this is an\noff-spec item (for example dps gear for\nhealers) \nor you have ALREADY received loot.\nBidWar mode use this button to place bid."
L.bidwarhint = "Mousewheel up/Left Click - Increase bid.\nMousewheel down/Right Click - decrease bid.\nSHIFT-KEY - change bid by +/-1\nALT-KEY - change bid by +/-20"
L.needhint = "Need.\nUse this option if you want this item."
L.pointstext = " points"



if (GetLocale() == "deDE") then
	L.passhint = "Passen.\nBenutze diese Option, wenn dud as Item nicht brauchst."
	L.takehint = "Nehmen.\nBenutze diese Option, wenn du das Item\nnehmen kannst, aber es nicht unbedingt willst\noder jemand Anderem den Vorzug geben willst.\nNutze diese Option alternativ, wenn das ein Zweititem ist\n(z.B. dps-Gear f/195/188r Heiler) oder wenn du\nin diesem Raid bereits Loot erhalten hast.\nBidWar Modus: Benutze diese Option um dein Gebot abzugeben."
	L.bidwarhint = "Mausrad hoch/Linksklick  Gebot erh/195/182hen.\nMausrad runter/Rechtsklick  Gebot verringern.\nSHIFT-Taste  Gebot /195/164ndern um +/-1\nALT-Taste  Gebot /195/164ndern um +/-20"
	L.needhint = "Bedarf.\nBenutze diese Option wenn du das item willst."
	L.pointstext = " punkte"
end

function MorgBid:Enable()
	-- initialize the loot frames
	self.frames = { }
	self.version = "3.6"
	bid = { }
	origbid = { }
	bidstep = 5
	self.overbid = 0
	self.dkp = 0
	-- set up the event frame
	self.frame = CreateFrame('Frame', nil, UIParent)
	self.frame:SetScript('OnEvent', function() self:OnEvent() end)
	self.frame:RegisterEvent("CHAT_MSG_ADDON")
end

function MorgBid:CreateFrame(itemid)
	local f = CreateFrame("Button", "MorgBidFrame"..itemid, UIParent)
    	f:EnableMouse(true)
    	f:SetFrameStrata("DIALOG")
    	f:RegisterForClicks("LeftButtonUp", "RightButtonUp", "MiddleButtonUp", "Button4Up", "Button5Up")
    	f:EnableMouseWheel(1)
	f:SetMovable(1)
   	f:RegisterForDrag("LeftButton")
   	f:SetScript("OnDragStart", function() f:StartMoving() end)
   	f:SetScript("OnDragStop", function() 
   					f:StopMovingOrSizing() 
   					local p, t, v, x, y = this:GetPoint()
					MorgBidDB.X = math.floor(x)
					MorgBidDB.Y = math.floor(y)
					MorgBidDB.AttachPoint = v
					--DEFAULT_CHAT_FRAME:AddMessage("x "..MorgBidDB.X.."y "..MorgBidDB.Y.."Point "..MorgBidDB.AttachPoint)
				end)
	
	f.icon = CreateFrame("Button", "MorgBidIcon", f)
	f.icon:SetWidth(32)
	f.icon:SetHeight(32)
	f.icon:ClearAllPoints()
	f.icon:SetPoint("TOPLEFT", f, "TOPLEFT", 5, -5)
	f.icon:SetScript("OnEnter", function()
		local item = "item:" .. this:GetParent():GetID() .. ":0:0:0"
		GameTooltip:SetOwner(this, "ANCHOR_RIGHT");
		GameTooltip:SetHyperlink(item);
		CursorUpdate();
	end)
	f.icon:SetScript("OnLeave", function() GameTooltip:Hide() end)
	f.icon:Show()
	
	f.name = f:CreateFontString(nil, "OVERLAY")
	f.name:SetFontObject(GameFontNormalSmall)
	f.name:SetJustifyH("LEFT")
	f.name:SetWidth(200)
	f.name:SetHeight(20)
	f.name:ClearAllPoints()
	f.name:SetPoint("LEFT", f.icon, "RIGHT", 10, 5)
	
	f.subname = f:CreateFontString(nil, "OVERLAY")
	f.subname:SetFontObject(GameFontHighlightSmall)
	f.subname:SetJustifyH("LEFT")
	f.subname:SetWidth(200)
	f.subname:SetHeight(20)
	f.subname:ClearAllPoints()
	f.subname:SetPoint("LEFT", f.icon, "RIGHT", 10, -5)
	
	f.dkp = f:CreateFontString(nil, "OVERLAY")
	f.dkp:SetFontObject(GameFontHighlightSmall)
	f.dkp:SetJustifyH("LEFT")
	f.dkp:SetWidth(200)
	f.dkp:SetHeight(20)
	f.dkp:ClearAllPoints()
	f.dkp:SetPoint("BOTTOMLEFT", f, "BOTTOMLEFT", 5, 10)

	f.passbutton = CreateFrame("Button", "MorgBidPassButton", f)
	f.passbutton:SetWidth(32)
	f.passbutton:SetHeight(32)
	f.passbutton:ClearAllPoints()
	f.passbutton:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", -5, 4)
	f.passbutton:SetNormalTexture("Interface\\Icons\\INV_Enchant_ShardNexusLarge")
	f.passbutton:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Pass-Highlight")
	f.passbutton:SetScript("OnClick", function() self:HandleDialogAction(this:GetParent(), "PASS") end)
	f.passbutton:SetScript("OnEnter", function()
		GameTooltip:SetOwner(this, "ANCHOR_RIGHT")
		GameTooltip:SetText(L.passhint)
	end)
	f.passbutton:SetScript("OnLeave", function() GameTooltip:Hide() end)
	f.passbutton:Show()

	f.takebutton = CreateFrame("Button", "MorgBidTakeButton", f)
	f.takebutton:SetWidth(32)
	f.takebutton:SetHeight(32)
	f.takebutton:ClearAllPoints()
	f.takebutton:SetPoint("RIGHT", f.passbutton, "LEFT", -10, 0)
	f.takebutton:SetNormalTexture("Interface\\Buttons\\UI-GroupLoot-Coin-Up")
	f.takebutton:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Coin-Highlight")
	f.takebutton:SetScript("OnClick", function() self:HandleDialogAction(this:GetParent(), "TAKE") end)
	f.takebutton:SetScript("OnEnter", function()
		GameTooltip:SetOwner(this, "ANCHOR_RIGHT")
		GameTooltip:SetText(L.takehint)
	end)
	f.takebutton:SetScript("OnLeave", function() GameTooltip:Hide() end)
	f.takebutton:Show()
	
	if BIDWAR then
		f.bidbutton = CreateFrame("Button", "MorgBidBidButton", f)
		f.bidbutton:EnableMouseWheel(1)
		f.bidbutton:SetWidth(32)
		f.bidbutton:SetHeight(32)
		f.bidbutton:ClearAllPoints()
		f.bidbutton:SetPoint("RIGHT", f.takebutton, "LEFT", -10, 0)
		f.bidbutton:SetNormalTexture("Interface\\Buttons\\ButtonHilight-Square")
		f.bidbutton:SetTextFontObject("GameFontNormal")
		f.bidbutton:SetTextColor(0,1,0)
		f.bidbutton:SetText(bid[itemid])
		f.bidbutton:SetScript("OnMouseWheel", function() self:HandleBidWarAction(this:GetParent(), arg1) end)
		f.bidbutton:SetScript("OnMouseUp", function() self:HandleBidWarAction(this:GetParent(), arg1) end)
		f.bidbutton:SetScript("OnEnter", function()
			GameTooltip:SetOwner(this, "ANCHOR_RIGHT")
			GameTooltip:SetText(L.bidwarhint)
		end)
		f.bidbutton:SetScript("OnLeave", function() GameTooltip:Hide() end)
		f.bidbutton:Show()
	else
		f.needbutton = CreateFrame("Button", "MorgBidNeedButton", f)
		f.needbutton:SetWidth(32)
		f.needbutton:SetHeight(32)
		f.needbutton:ClearAllPoints()
		f.needbutton:SetPoint("RIGHT", f.takebutton, "LEFT", -10, 0)
		f.needbutton:SetNormalTexture("Interface\\Buttons\\UI-GroupLoot-Dice-Up")
		f.needbutton:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Dice-Highlight")
		f.needbutton:SetScript("OnClick", function() self:HandleDialogAction(this:GetParent(), "NEED") end)
		f.needbutton:SetScript("OnEnter", function()
			GameTooltip:SetOwner(this, "ANCHOR_RIGHT")
			GameTooltip:SetText(L.needhint)
		end)
		f.needbutton:SetScript("OnLeave", function() GameTooltip:Hide() end)
		f.needbutton:Show()
	end
	
	f:SetBackdrop({ bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16, edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16, insets = { left = 3, right = 3, top = 3, bottom = 3 } })
	f:SetBackdropColor(.25, .25, .25, .75)
	f:SetBackdropBorderColor(1, 1, 1, 1)
	
	f:SetWidth(200) f:SetHeight(75)
	f:SetScale(1.2)
	f:ClearAllPoints()
	if MorgBidDB.X and MorgBidDB.Y and MorgBidDB.AttachPoint then
		f:SetPoint(MorgBidDB.AttachPoint, UIParent, MorgBidDB.AttachPoint, MorgBidDB.X, MorgBidDB.Y)
	else 
		local point = "CENTER"
		f:SetPoint(point, UIParent, point, 0, 0)
		MorgBidDB.X, MorgBidDB.Y, MorgBidDB.AttachPoint = 0,0,point
	end
 	f:SetID(itemid)
	table.insert(self.frames, { frame = f, id = itemid })
	return f
end

function MorgBid:AddItemDialog(item, points, dkp)
	origbid[item] = points
	bid[item] = points
	local f = self:CreateFrame(item)
	--DEFAULT_CHAT_FRAME:AddMessage("item "..item.."x "..MorgBidDB.X.."y "..MorgBidDB.Y.."Point "..MorgBidDB.AttachPoint)
	
	local sName, sLink, iQuality, _, iLevel, sType, sSubType, iCount, iLoc, iTexture = GetItemInfo(item)
	f.icon:SetNormalTexture(iTexture)
	f.name:SetText(sName)
	if points then
		f.subname:SetText(points..L.pointstext)
		f.subname:Show()
	else
		f.subname:Hide()
	end
	if dkp ~= "NONE" then
		self.dkp = dkp
		f.dkp:SetText("|c001eff00"..dkp)
		f.dkp:Show()
	else
		f.dkp:Hide()
	end
	self:SortDialogs()
end

function MorgBid:HandleDialogAction(frame, action)
	local item = frame:GetID()
	self:RemoveFrame(item)
	if MorgBidDB.X then self:SortDialogs() end
	SendAddonMessage("MORGBID", action.." "..item.." "..bid[item],"RAID")
	DEFAULT_CHAT_FRAME:AddMessage("Action: "..action.." on item "..item.." "..bid[item])
end

function MorgBid:RemoveFrame(itemid)
	for i,v in pairs(self.frames) do
		if v.id == itemid then 
			v.frame:Hide()
			table.remove(self.frames, i)
			break
		end
	end
	self:SortDialogs()
end

function MorgBid:SortDialogs()
	local ct = 0
	for i,v in pairs(self.frames) do
		v.frame:ClearAllPoints()
		v.frame:SetPoint(MorgBidDB.AttachPoint, UIParent, MorgBidDB.AttachPoint, MorgBidDB.X, MorgBidDB.Y  + ct*80)
		ct = ct + 1
	end
end

function MorgBid:OnEvent()
	local prefix, message, type, sender = arg1, arg2, arg3, arg4
	if prefix == "MORGBID" then
		local args = {self:Explode(message, " ")}
		if args[1] == "QUERY" then
			BIDWAR = nil
			local item, points = args[2], args[3]
			if args[4] == UnitName("player") then self:AddItemDialog(item, points, args[5]) return end
    		elseif args[1] == "CHECK" then
    			SendAddonMessage("MORGBID", "REPLY "..UnitName("player").." "..self.version,"RAID")
    		elseif args[1] == "BIDWAR" then
			BIDWAR = true
			local item, points = args[2], args[3]
			bidstep = tonumber(args[6])
			self.overbid = tonumber(args[7])
			if args[4] == UnitName("player") then self:AddItemDialog(item, points, args[5]) return end
		elseif args[1] == "CLOSE" then self:RemoveFrame(tonumber(args[2])) 
		end
	end
end

function MorgBid:Split(string, sep)
	if not string then error("Bad String", 2)     end
	local x = strfind(string , sep) or 0
	return (tonumber(strsub(string, 1, x-1)) or strsub(string, 1, x-1)), (tonumber(strsub(string, x+1)) or strsub(string, x+1))
end
function MorgBid:Explode(string, sep)
	if not string then return nil end
	local a, b = self:Split(string, sep)
	if not b or b == "" then return a; end
	if not strfind(b or "", sep) then return a, b; end
	return a, self:Explode(b, sep)
end 

function MorgBid:HandleBidWarAction(frame, button)
	local origbidstep = bidstep
	local tempbid = bid[frame:GetID()]
	local maxbid = self.dkp + self.overbid
	if IsShiftKeyDown() then bidstep = 1 end
	if IsAltKeyDown() then bidstep = 20 end
	if button == 1 then tempbid = tempbid + bidstep 
	elseif button == -1 then tempbid = tempbid - bidstep 
	elseif button == "LeftButton" then tempbid = tempbid + bidstep 
	elseif button == "RightButton" then tempbid = tempbid - bidstep 
	end
	if tempbid < origbid[frame:GetID()] then tempbid = origbid[frame:GetID()] end
	if tempbid > maxbid then tempbid = maxbid end
	frame.bidbutton:SetText(tempbid)
	bid[frame:GetID()] = tempbid
	bidstep = origbidstep
end

MorgBid:Enable()
